'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _testcafeBrowserNatives = require('testcafe-browser-natives');

var _testcafeBrowserNatives2 = _interopRequireDefault(_testcafeBrowserNatives);

var _osFamily = require('os-family');

var _osFamily2 = _interopRequireDefault(_osFamily);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PathBrowserProvider = function (_BrowserProviderBase) {
    (0, _inherits3.default)(PathBrowserProvider, _BrowserProviderBase);

    function PathBrowserProvider() {
        (0, _classCallCheck3.default)(this, PathBrowserProvider);

        var _this = (0, _possibleConstructorReturn3.default)(this, _BrowserProviderBase.call(this));

        _this.isMultiBrowser = true;
        return _this;
    }

    PathBrowserProvider.prototype._handleJSON = function _handleJSON(str) {
        var params = null;

        try {
            params = JSON.parse(str);
        } catch (e) {
            return null;
        }

        if (!params.path) return null;

        var openParameters = _testcafeBrowserNatives2.default.getBrowserInfo(params.path);

        if (!openParameters) return null;

        if (params.cmd) openParameters.cmd = params.cmd;

        return openParameters;
    };

    PathBrowserProvider.prototype.openBrowser = function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(id, alias, startPage) {
            var openParameters;
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.next = 2;
                            return _testcafeBrowserNatives2.default.getBrowserInfo(alias);

                        case 2:
                            _context.t0 = _context.sent;

                            if (_context.t0) {
                                _context.next = 5;
                                break;
                            }

                            _context.t0 = this._handleJSON(alias);

                        case 5:
                            openParameters = _context.t0;

                            if (openParameters) {
                                _context.next = 8;
                                break;
                            }

                            throw new Error('The specified browser name is not valid!');

                        case 8:
                            _context.next = 10;
                            return _testcafeBrowserNatives2.default.open(openParameters, startPage);

                        case 10:
                            if (!_osFamily2.default.win) {
                                _context.next = 13;
                                break;
                            }

                            _context.next = 13;
                            return _BrowserProviderBase.prototype.calculateResizeCorrections.call(this, id);

                        case 13:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));

        function openBrowser(_x, _x2, _x3) {
            return _ref.apply(this, arguments);
        }

        return openBrowser;
    }();

    PathBrowserProvider.prototype.closeBrowser = function () {
        var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(id, pageInfo) {
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            _context2.next = 2;
                            return _testcafeBrowserNatives2.default.close(pageInfo.title);

                        case 2:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        function closeBrowser(_x4, _x5) {
            return _ref2.apply(this, arguments);
        }

        return closeBrowser;
    }();

    PathBrowserProvider.prototype.getBrowserList = function () {
        var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
            return _regenerator2.default.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            return _context3.abrupt('return', ['${PATH_TO_BROWSER_EXECUTABLE}']);

                        case 1:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, _callee3, this);
        }));

        function getBrowserList() {
            return _ref3.apply(this, arguments);
        }

        return getBrowserList;
    }();

    return PathBrowserProvider;
}(_base2.default);

exports.default = PathBrowserProvider;
module.exports = exports['default'];