'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _pinkie = require('pinkie');

var _pinkie2 = _interopRequireDefault(_pinkie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BrowserProviderCacheItem = function () {
    function BrowserProviderCacheItem(provider) {
        (0, _classCallCheck3.default)(this, BrowserProviderCacheItem);

        this.provider = provider;
        this.initPromise = _pinkie2.default.resolve(false);
    }

    BrowserProviderCacheItem.prototype.init = function init() {
        var _this = this;

        this.initPromise = this.initPromise.then(function (initialized) {
            return initialized ? _pinkie2.default.resolve() : _this.provider.init();
        }).then(function () {
            return true;
        }).catch(function () {
            return false;
        });

        return this.initPromise;
    };

    BrowserProviderCacheItem.prototype.dispose = function dispose() {
        var _this2 = this;

        this.initPromise = this.initPromise.then(function (initialized) {
            return initialized ? _this2.provider.dispose() : _pinkie2.default.resolve();
        }).then(function () {
            return false;
        }).catch(function () {
            return false;
        });

        return this.initPromise;
    };

    return BrowserProviderCacheItem;
}();

exports.default = BrowserProviderCacheItem;
module.exports = exports['default'];